Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
$(() => {
const URL = 'https://js.devexpress.com/Demos/NetCore/api/DataGridWebApi';
const ordersStore = new DevExpress.data.CustomStore({
key: 'OrderID',
load() {
return sendRequest(`${URL}/Orders`);
},
insert(values) {
return sendRequest(`${URL}/InsertOrder`, 'POST', {
values: JSON.stringify(values),
});
},
update(key, values) {
return sendRequest(`${URL}/UpdateOrder`, 'PUT', {
key,
values: JSON.stringify(values),
});
},
remove(key) {
return sendRequest(`${URL}/DeleteOrder`, 'DELETE', {
key,
});
},
});
const dataGrid = $('#grid').dxDataGrid({
dataSource: ordersStore,
repaintChangesOnly: true,
showBorders: true,
editing: {
refreshMode: 'reshape',
mode: 'cell',
allowAdding: true,
allowUpdating: true,
allowDeleting: true,
},
scrolling: {
mode: 'virtual',
},
columns: [{
dataField: 'CustomerID',
caption: 'Customer',
lookup: {
dataSource: {
paginate: true,
store: new DevExpress.data.CustomStore({
key: 'Value',
loadMode: 'raw',
load() {
return sendRequest(`${URL}/CustomersLookup`);
},
}),
},
valueExpr: 'Value',
displayExpr: 'Text',
},
}, {
dataField: 'OrderDate',
dataType: 'date',
}, {
dataField: 'Freight',
}, {
dataField: 'ShipCountry',
}, {
dataField: 'ShipVia',
caption: 'Shipping Company',
dataType: 'number',
lookup: {
dataSource: new DevExpress.data.CustomStore({
key: 'Value',
loadMode: 'raw',
load() {
return sendRequest(`${URL}/ShippersLookup`);
},
}),
valueExpr: 'Value',
displayExpr: 'Text',
},
},
],
summary: {
totalItems: [{
column: 'CustomerID',
summaryType: 'count',
}, {
column: 'Freight',
valueFormat: '#0.00',
summaryType: 'sum',
}],
},
}).dxDataGrid('instance');
$('#refresh-mode').dxSelectBox({
items: ['full', 'reshape', 'repaint'],
value: 'reshape',
inputAttr: { 'aria-label': 'Refresh Mode' },
onValueChanged(e) {
dataGrid.option('editing.refreshMode', e.value);
},
});
$('#clear').dxButton({
text: 'Clear',
onClick() {
$('#requests ul').empty();
},
});
function sendRequest(url, method = 'GET', data) {
const d = $.Deferred();
logRequest(method, url, data);
$.ajax(url, {
method,
data,
cache: false,
xhrFields: { withCredentials: true },
}).done((result) => {
d.resolve(method === 'GET' ? result.data : result);
}).fail((xhr) => {
d.reject(xhr.responseJSON ? xhr.responseJSON.Message : xhr.statusText);
});
return d.promise();
}
function logRequest(method, url, data) {
const args = Object.keys(data || {}).map((key) => `${key}=${data[key]}`).join(' ');
const logList = $('#requests ul');
const time = DevExpress.localization.formatDate(new Date(), 'HH:mm:ss');
const newItem = $('<li>').text([time, method, url.slice(URL.length), args].join(' '));
logList.prepend(newItem);
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.3/css/dx.light.css" />
<script src="js/dx.all.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="grid"></div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Refresh Mode:</span>
<div id="refresh-mode"></div>
</div>
<div id="requests">
<div>
<div class="caption">Network Requests</div>
<div id="clear"></div>
</div>
<ul></ul>
</div>
</div>
</div>
</body>
</html>
#grid {
height: 440px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
margin-bottom: 10px;
font-weight: 500;
font-size: 18px;
}
.option {
margin-bottom: 10px;
}
.option > span {
position: relative;
top: 2px;
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
#requests .caption {
float: left;
padding-top: 7px;
}
#requests > div {
padding-bottom: 5px;
}
#requests > div::after {
content: "";
display: table;
clear: both;
}
#requests #clear {
float: right;
}
#requests ul {
list-style: none;
max-height: 100px;
overflow: auto;
margin: 0;
}
#requests ul li {
padding: 7px 0;
border-bottom: 1px solid #ddd;
}
#requests ul li:last-child {
border-bottom: none;
}
using DevExtreme.AspNet.Data;
using DevExtreme.AspNet.Mvc;
using Newtonsoft.Json;
using System;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Web.Http;
using DevExtreme.MVC.Demos.Models.Northwind;
using DevExtreme.MVC.Demos.Models.DataGrid;
using System.Collections.Generic;
namespace DevExtreme.MVC.Demos.Controllers {
[Route("api/DataGridWebApi/{action}", Name = "DataGridWebApi")]
public class DataGridWebApiController : ApiController {
InMemoryNorthwindContext _nwind = new InMemoryNorthwindContext();
[HttpGet]
public HttpResponseMessage Orders(DataSourceLoadOptions loadOptions) {
return Request.CreateResponse(DataSourceLoader.Load(_nwind.Orders, loadOptions));
}
[HttpPost]
public HttpResponseMessage InsertOrder(FormDataCollection form) {
var values = form.Get("values");
var newOrder = new Order();
JsonConvert.PopulateObject(values, newOrder);
Validate(newOrder);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
_nwind.Orders.Add(newOrder);
_nwind.SaveChanges();
return Request.CreateResponse(HttpStatusCode.Created, newOrder);
}
[HttpPut]
public HttpResponseMessage UpdateOrder(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var values = form.Get("values");
var order = _nwind.Orders.First(o => o.OrderID == key);
JsonConvert.PopulateObject(values, order);
Validate(order);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
_nwind.SaveChanges();
return Request.CreateResponse(HttpStatusCode.OK, order);
}
[HttpDelete]
public void DeleteOrder(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var order = _nwind.Orders.First(o => o.OrderID == key);
_nwind.Orders.Remove(order);
_nwind.SaveChanges();
}
// additional actions
[HttpGet]
public HttpResponseMessage OrderDetails(int orderID, DataSourceLoadOptions loadOptions) {
return Request.CreateResponse(DataSourceLoader.Load(
from i in _nwind.Order_Details
where i.OrderID == orderID
select new {
Product = i.Product.ProductName,
Price = i.UnitPrice,
i.Quantity,
Sum = i.UnitPrice * i.Quantity
},
loadOptions
));
}
[HttpGet]
public HttpResponseMessage ShippersLookup(DataSourceLoadOptions loadOptions) {
var lookup = from i in _nwind.Shippers
orderby i.CompanyName
select new {
Value = i.ShipperID,
Text = i.CompanyName
};
return Request.CreateResponse(DataSourceLoader.Load(lookup, loadOptions));
}
[HttpGet]
public HttpResponseMessage CustomersLookup(DataSourceLoadOptions loadOptions) {
var lookup = from i in _nwind.Customers
let text = i.CompanyName + " (" + i.Country + ")"
orderby i.CompanyName
select new {
Value = i.CustomerID,
Text = text
};
return Request.CreateResponse(DataSourceLoader.Load(lookup, loadOptions));
}
[HttpPost]
public HttpResponseMessage Batch(List<DataChange> changes) {
foreach(var change in changes) {
Order order;
if(change.Type == "update" || change.Type == "remove") {
var key = Convert.ToInt32(change.Key);
order = _nwind.Orders.First(o => o.OrderID == key);
} else {
order = new Order();
}
if(change.Type == "insert" || change.Type == "update") {
JsonConvert.PopulateObject(change.Data.ToString(), order);
Validate(order);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
if(change.Type == "insert") {
_nwind.Orders.Add(order);
}
change.Data = order;
} else if(change.Type == "remove") {
_nwind.Orders.Remove(order);
}
}
_nwind.SaveChanges();
return Request.CreateResponse(HttpStatusCode.OK, changes);
}
}
}
using System;
using System.Collections.Generic;
using System.Data.Entity;
namespace DevExtreme.MVC.Demos.Models.Northwind {
public class InMemoryNorthwindContext : InMemoryDataContext<Order> {
readonly NorthwindContext _nwind = new NorthwindContext();
public DbSet<Customer> Customers => _nwind.Customers;
public DbSet<Order_Detail> Order_Details => _nwind.Order_Details;
public ICollection<Order> Orders => ItemsInternal;
public DbSet<Shipper> Shippers => _nwind.Shippers;
protected override IEnumerable<Order> Source => _nwind.Orders;
protected override int GetKey(Order item) => item.OrderID;
protected override void SetKey(Order item, int key) => item.OrderID = key;
}
}

Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
<dx-data-grid
id="grid"
[dataSource]="dataSource"
[repaintChangesOnly]="true"
[showBorders]="true"
>
<dxo-scrolling mode="virtual"></dxo-scrolling>
<dxo-editing
mode="cell"
[refreshMode]="refreshMode"
[allowAdding]="true"
[allowUpdating]="true"
[allowDeleting]="true"
>
</dxo-editing>
<dxi-column dataField="CustomerID" caption="Customer">
<dxo-lookup
[dataSource]="customersData"
valueExpr="Value"
displayExpr="Text"
></dxo-lookup>
</dxi-column>
<dxi-column dataField="OrderDate" dataType="date"></dxi-column>
<dxi-column dataField="Freight"></dxi-column>
<dxi-column dataField="ShipCountry"></dxi-column>
<dxi-column dataField="ShipVia" caption="Shipping Company" dataType="number">
<dxo-lookup
[dataSource]="shippersData"
valueExpr="Value"
displayExpr="Text"
></dxo-lookup>
</dxi-column>
<dxo-summary>
<dxi-total-item column="CustomerID" summaryType="count"> </dxi-total-item>
<dxi-total-item column="Freight" summaryType="sum" valueFormat="#0.00">
</dxi-total-item>
</dxo-summary>
</dx-data-grid>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Refresh Mode:</span>
<dx-select-box
[(value)]="refreshMode"
[items]="refreshModes"
[inputAttr]="{ 'aria-label': 'Refresh Mode' }"
>
</dx-select-box>
</div>
<div id="requests">
<div>
<div class="caption">Network Requests</div>
<dx-button id="clear" text="Clear" (onClick)="clearRequests()">
</dx-button>
</div>
<ul>
<li *ngFor="let request of requests">{{ request }}</li>
</ul>
</div>
</div>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { HttpClient, HttpClientModule, HttpParams } from '@angular/common/http';
import { lastValueFrom, Observable } from 'rxjs';
import { DxDataGridModule, DxSelectBoxModule, DxButtonModule } from 'devextreme-angular';
import { CustomStore } from 'devextreme-angular/common/data';
import { formatDate } from 'devextreme-angular/common/core/localization';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
const URL = 'https://js.devexpress.com/Demos/NetCore/api/DataGridWebApi';
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
preserveWhitespaces: true,
})
export class AppComponent {
dataSource: CustomStore;
requests: string[] = [];
refreshModes = ['full', 'reshape', 'repaint'];
refreshMode = 'reshape';
customersData = {
paginate: true,
store: new CustomStore({
key: 'Value',
loadMode: 'raw',
load: () => this.sendRequest(`${URL}/CustomersLookup`),
}),
};
shippersData = new CustomStore({
key: 'Value',
loadMode: 'raw',
load: () => this.sendRequest(`${URL}/ShippersLookup`),
});
constructor(private http: HttpClient) {
this.dataSource = new CustomStore({
key: 'OrderID',
load: () => this.sendRequest(`${URL}/Orders`),
insert: (values) => this.sendRequest(`${URL}/InsertOrder`, 'POST', {
values: JSON.stringify(values),
}),
update: (key, values) => this.sendRequest(`${URL}/UpdateOrder`, 'PUT', {
key,
values: JSON.stringify(values),
}),
remove: (key) => this.sendRequest(`${URL}/DeleteOrder`, 'DELETE', {
key,
}),
});
}
async sendRequest(url: string, method = 'GET', data = {}) {
this.logRequest(method, url, data);
const httpParams = new HttpParams({ fromObject: data });
const httpOptions = { withCredentials: true, body: httpParams };
let request: Observable<Object>;
switch (method) {
case 'GET':
request = this.http.get(url, httpOptions);
break;
case 'PUT':
request = this.http.put(url, httpParams, httpOptions);
break;
case 'POST':
request = this.http.post(url, httpParams, httpOptions);
break;
case 'DELETE':
request = this.http.delete(url, httpOptions);
break;
}
try {
const result = await lastValueFrom<any>(request);
return method === 'GET' ? result.data : {};
} catch (e) {
throw e.error.Message;
}
}
logRequest(method: string, url: string, data: object): void {
const args = Object.keys(data || {}).map((key) => `${key}=${data[key]}`).join(' ');
const time = formatDate(new Date(), 'HH:mm:ss');
this.requests.unshift([time, method, url.slice(URL.length), args].join(' '));
}
clearRequests() {
this.requests = [];
}
}
@NgModule({
imports: [
BrowserModule,
DxDataGridModule,
DxSelectBoxModule,
DxButtonModule,
HttpClientModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #grid {
height: 440px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
margin-bottom: 10px;
font-weight: 500;
font-size: 18px;
}
.option {
margin-bottom: 10px;
}
.option > span {
position: relative;
top: 2px;
margin-right: 10px;
}
::ng-deep .option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
::ng-deep #requests .caption {
float: left;
padding-top: 7px;
}
::ng-deep #requests > div {
padding-bottom: 5px;
}
::ng-deep #requests > div::after {
content: "";
display: table;
clear: both;
}
::ng-deep #requests #clear {
float: right;
}
::ng-deep #requests ul {
list-style: none;
max-height: 100px;
overflow: auto;
margin: 0;
}
::ng-deep #requests ul li {
padding: 7px 0;
border-bottom: 1px solid #ddd;
}
::ng-deep #requests ul li:last-child {
border-bottom: none;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@25.1.3/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.3/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.19',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.62',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.19/package.json',
'npm:devexpress-gantt@4.1.62/package.json',
],
};
System.config(window.config);
// System.import('@angular/compiler').catch(console.error.bind(console));
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.14.10/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
using DevExtreme.AspNet.Data;
using DevExtreme.AspNet.Mvc;
using Newtonsoft.Json;
using System;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Web.Http;
using DevExtreme.MVC.Demos.Models.Northwind;
using DevExtreme.MVC.Demos.Models.DataGrid;
using System.Collections.Generic;
namespace DevExtreme.MVC.Demos.Controllers {
[Route("api/DataGridWebApi/{action}", Name = "DataGridWebApi")]
public class DataGridWebApiController : ApiController {
InMemoryNorthwindContext _nwind = new InMemoryNorthwindContext();
[HttpGet]
public HttpResponseMessage Orders(DataSourceLoadOptions loadOptions) {
return Request.CreateResponse(DataSourceLoader.Load(_nwind.Orders, loadOptions));
}
[HttpPost]
public HttpResponseMessage InsertOrder(FormDataCollection form) {
var values = form.Get("values");
var newOrder = new Order();
JsonConvert.PopulateObject(values, newOrder);
Validate(newOrder);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
_nwind.Orders.Add(newOrder);
_nwind.SaveChanges();
return Request.CreateResponse(HttpStatusCode.Created, newOrder);
}
[HttpPut]
public HttpResponseMessage UpdateOrder(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var values = form.Get("values");
var order = _nwind.Orders.First(o => o.OrderID == key);
JsonConvert.PopulateObject(values, order);
Validate(order);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
_nwind.SaveChanges();
return Request.CreateResponse(HttpStatusCode.OK, order);
}
[HttpDelete]
public void DeleteOrder(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var order = _nwind.Orders.First(o => o.OrderID == key);
_nwind.Orders.Remove(order);
_nwind.SaveChanges();
}
// additional actions
[HttpGet]
public HttpResponseMessage OrderDetails(int orderID, DataSourceLoadOptions loadOptions) {
return Request.CreateResponse(DataSourceLoader.Load(
from i in _nwind.Order_Details
where i.OrderID == orderID
select new {
Product = i.Product.ProductName,
Price = i.UnitPrice,
i.Quantity,
Sum = i.UnitPrice * i.Quantity
},
loadOptions
));
}
[HttpGet]
public HttpResponseMessage ShippersLookup(DataSourceLoadOptions loadOptions) {
var lookup = from i in _nwind.Shippers
orderby i.CompanyName
select new {
Value = i.ShipperID,
Text = i.CompanyName
};
return Request.CreateResponse(DataSourceLoader.Load(lookup, loadOptions));
}
[HttpGet]
public HttpResponseMessage CustomersLookup(DataSourceLoadOptions loadOptions) {
var lookup = from i in _nwind.Customers
let text = i.CompanyName + " (" + i.Country + ")"
orderby i.CompanyName
select new {
Value = i.CustomerID,
Text = text
};
return Request.CreateResponse(DataSourceLoader.Load(lookup, loadOptions));
}
[HttpPost]
public HttpResponseMessage Batch(List<DataChange> changes) {
foreach(var change in changes) {
Order order;
if(change.Type == "update" || change.Type == "remove") {
var key = Convert.ToInt32(change.Key);
order = _nwind.Orders.First(o => o.OrderID == key);
} else {
order = new Order();
}
if(change.Type == "insert" || change.Type == "update") {
JsonConvert.PopulateObject(change.Data.ToString(), order);
Validate(order);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
if(change.Type == "insert") {
_nwind.Orders.Add(order);
}
change.Data = order;
} else if(change.Type == "remove") {
_nwind.Orders.Remove(order);
}
}
_nwind.SaveChanges();
return Request.CreateResponse(HttpStatusCode.OK, changes);
}
}
}
using System;
using System.Collections.Generic;
using System.Data.Entity;
namespace DevExtreme.MVC.Demos.Models.Northwind {
public class InMemoryNorthwindContext : InMemoryDataContext<Order> {
readonly NorthwindContext _nwind = new NorthwindContext();
public DbSet<Customer> Customers => _nwind.Customers;
public DbSet<Order_Detail> Order_Details => _nwind.Order_Details;
public ICollection<Order> Orders => ItemsInternal;
public DbSet<Shipper> Shippers => _nwind.Shippers;
protected override IEnumerable<Order> Source => _nwind.Orders;
protected override int GetKey(Order item) => item.OrderID;
protected override void SetKey(Order item, int key) => item.OrderID = key;
}
}

Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
// eslint-disable-next-line no-unused-vars
/* global RequestInit */
import React, { useCallback, useState } from 'react';
import {
DataGrid, Column, Editing, Scrolling, Lookup, Summary, TotalItem, type DataGridTypes,
} from 'devextreme-react/data-grid';
import { Button } from 'devextreme-react/button';
import { SelectBox, type SelectBoxTypes } from 'devextreme-react/select-box';
import { CustomStore } from 'devextreme-react/common/data';
import { formatDate } from 'devextreme-react/common/core/localization';
import 'whatwg-fetch';
const refreshModeLabel = { 'aria-label': 'Refresh Mode' };
const URL = 'https://js.devexpress.com/Demos/NetCore/api/DataGridWebApi';
const REFRESH_MODES = ['full', 'reshape', 'repaint'];
const App = () => {
const [ordersData] = useState(new CustomStore({
key: 'OrderID',
load: () => sendRequest(`${URL}/Orders`),
insert: (values) => sendRequest(`${URL}/InsertOrder`, 'POST', {
values: JSON.stringify(values),
}),
update: (key, values) => sendRequest(`${URL}/UpdateOrder`, 'PUT', {
key,
values: JSON.stringify(values),
}),
remove: (key) => sendRequest(`${URL}/DeleteOrder`, 'DELETE', {
key,
}),
}));
const [customersData] = useState(new CustomStore({
key: 'Value',
loadMode: 'raw',
load: () => sendRequest(`${URL}/CustomersLookup`),
}));
const [shippersData] = useState(new CustomStore({
key: 'Value',
loadMode: 'raw',
load: () => sendRequest(`${URL}/ShippersLookup`),
}));
const [requests, setRequests] = useState([]);
const [refreshMode, setRefreshMode] = useState<DataGridTypes.GridsEditRefreshMode>('reshape');
const handleRefreshModeChange = useCallback((e: SelectBoxTypes.ValueChangedEvent) => {
setRefreshMode(e.value);
}, []);
const clearRequests = useCallback(() => {
setRequests([]);
}, []);
const logRequest = useCallback((method, url: string, data: Record<string, any>) => {
const args = Object.keys(data || {}).map((key) => `${key}=${data[key]}`).join(' ');
const time = formatDate(new Date(), 'HH:mm:ss');
const request = [time, method, url.slice(URL.length), args].join(' ');
setRequests((prevRequests: ConcatArray<string>) => [request].concat(prevRequests));
}, []);
// eslint-disable-next-line consistent-return, space-before-function-paren
const sendRequest = useCallback(async (url: string, method = 'GET', data = {}) => {
logRequest(method, url, data);
const request: RequestInit = {
method, credentials: 'include',
};
if (['DELETE', 'POST', 'PUT'].includes(method)) {
const params = Object.keys(data)
.map((key) => `${encodeURIComponent(key)}=${encodeURIComponent(data[key])}`)
.join('&');
request.body = params;
request.headers = { 'Content-Type': 'application/x-www-form-urlencoded;charset=UTF-8' };
}
const response = await fetch(url, request);
const isJson = response.headers.get('content-type')?.includes('application/json');
const result = isJson ? await response.json() : {};
if (!response.ok) {
throw result.Message;
}
return method === 'GET' ? result.data : {};
}, [logRequest]);
return (
<React.Fragment>
<DataGrid
id="grid"
showBorders={true}
dataSource={ordersData}
repaintChangesOnly={true}
>
<Editing
refreshMode={refreshMode}
mode="cell"
allowAdding={true}
allowDeleting={true}
allowUpdating={true}
/>
<Scrolling mode="virtual" />
<Column dataField="CustomerID" caption="Customer">
<Lookup dataSource={customersData} valueExpr="Value" displayExpr="Text" />
</Column>
<Column dataField="OrderDate" dataType="date" />
<Column dataField="Freight" />
<Column dataField="ShipCountry" />
<Column
dataField="ShipVia"
caption="Shipping Company"
dataType="number"
>
<Lookup dataSource={shippersData} valueExpr="Value" displayExpr="Text" />
</Column>
<Summary>
<TotalItem column="CustomerID" summaryType="count" />
<TotalItem column="Freight" summaryType="sum" valueFormat="#0.00" />
</Summary>
</DataGrid>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Refresh Mode: </span>
<SelectBox
value={refreshMode}
inputAttr={refreshModeLabel}
items={REFRESH_MODES}
onValueChanged={handleRefreshModeChange}
/>
</div>
<div id="requests">
<div>
<div className="caption">Network Requests</div>
<Button id="clear" text="Clear" onClick={clearRequests} />
</div>
<ul>
{requests.map((request, index) => <li key={index}>{request}</li>)}
</ul>
</div>
</div>
</React.Fragment>
);
};
export default App;
// eslint-disable-next-line no-unused-vars
/* global RequestInit */
import React, { useCallback, useState } from 'react';
import {
DataGrid,
Column,
Editing,
Scrolling,
Lookup,
Summary,
TotalItem,
} from 'devextreme-react/data-grid';
import { Button } from 'devextreme-react/button';
import { SelectBox } from 'devextreme-react/select-box';
import { CustomStore } from 'devextreme-react/common/data';
import { formatDate } from 'devextreme-react/common/core/localization';
import 'whatwg-fetch';
const refreshModeLabel = { 'aria-label': 'Refresh Mode' };
const URL = 'https://js.devexpress.com/Demos/NetCore/api/DataGridWebApi';
const REFRESH_MODES = ['full', 'reshape', 'repaint'];
const App = () => {
const [ordersData] = useState(
new CustomStore({
key: 'OrderID',
load: () => sendRequest(`${URL}/Orders`),
insert: (values) =>
sendRequest(`${URL}/InsertOrder`, 'POST', {
values: JSON.stringify(values),
}),
update: (key, values) =>
sendRequest(`${URL}/UpdateOrder`, 'PUT', {
key,
values: JSON.stringify(values),
}),
remove: (key) =>
sendRequest(`${URL}/DeleteOrder`, 'DELETE', {
key,
}),
}),
);
const [customersData] = useState(
new CustomStore({
key: 'Value',
loadMode: 'raw',
load: () => sendRequest(`${URL}/CustomersLookup`),
}),
);
const [shippersData] = useState(
new CustomStore({
key: 'Value',
loadMode: 'raw',
load: () => sendRequest(`${URL}/ShippersLookup`),
}),
);
const [requests, setRequests] = useState([]);
const [refreshMode, setRefreshMode] = useState('reshape');
const handleRefreshModeChange = useCallback((e) => {
setRefreshMode(e.value);
}, []);
const clearRequests = useCallback(() => {
setRequests([]);
}, []);
const logRequest = useCallback((method, url, data) => {
const args = Object.keys(data || {})
.map((key) => `${key}=${data[key]}`)
.join(' ');
const time = formatDate(new Date(), 'HH:mm:ss');
const request = [time, method, url.slice(URL.length), args].join(' ');
setRequests((prevRequests) => [request].concat(prevRequests));
}, []);
// eslint-disable-next-line consistent-return, space-before-function-paren
const sendRequest = useCallback(
async(url, method = 'GET', data = {}) => {
logRequest(method, url, data);
const request = {
method,
credentials: 'include',
};
if (['DELETE', 'POST', 'PUT'].includes(method)) {
const params = Object.keys(data)
.map((key) => `${encodeURIComponent(key)}=${encodeURIComponent(data[key])}`)
.join('&');
request.body = params;
request.headers = { 'Content-Type': 'application/x-www-form-urlencoded;charset=UTF-8' };
}
const response = await fetch(url, request);
const isJson = response.headers.get('content-type')?.includes('application/json');
const result = isJson ? await response.json() : {};
if (!response.ok) {
throw result.Message;
}
return method === 'GET' ? result.data : {};
},
[logRequest],
);
return (
<React.Fragment>
<DataGrid
id="grid"
showBorders={true}
dataSource={ordersData}
repaintChangesOnly={true}
>
<Editing
refreshMode={refreshMode}
mode="cell"
allowAdding={true}
allowDeleting={true}
allowUpdating={true}
/>
<Scrolling mode="virtual" />
<Column
dataField="CustomerID"
caption="Customer"
>
<Lookup
dataSource={customersData}
valueExpr="Value"
displayExpr="Text"
/>
</Column>
<Column
dataField="OrderDate"
dataType="date"
/>
<Column dataField="Freight" />
<Column dataField="ShipCountry" />
<Column
dataField="ShipVia"
caption="Shipping Company"
dataType="number"
>
<Lookup
dataSource={shippersData}
valueExpr="Value"
displayExpr="Text"
/>
</Column>
<Summary>
<TotalItem
column="CustomerID"
summaryType="count"
/>
<TotalItem
column="Freight"
summaryType="sum"
valueFormat="#0.00"
/>
</Summary>
</DataGrid>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Refresh Mode: </span>
<SelectBox
value={refreshMode}
inputAttr={refreshModeLabel}
items={REFRESH_MODES}
onValueChanged={handleRefreshModeChange}
/>
</div>
<div id="requests">
<div>
<div className="caption">Network Requests</div>
<Button
id="clear"
text="Clear"
onClick={clearRequests}
/>
</div>
<ul>
{requests.map((request, index) => (
<li key={index}>{request}</li>
))}
</ul>
</div>
</div>
</React.Fragment>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'whatwg-fetch': 'npm:whatwg-fetch@2.0.4/fetch.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@25.1.3/cjs',
'devextreme-react': 'npm:devextreme-react@25.1.3/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.3/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.19/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.62/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#grid {
height: 440px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
margin-bottom: 10px;
font-weight: 500;
font-size: 18px;
}
.option {
margin-bottom: 10px;
}
.option > span {
position: relative;
top: 2px;
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
#requests .caption {
float: left;
padding-top: 7px;
}
#requests > div {
padding-bottom: 5px;
}
#requests > div::after {
content: "";
display: table;
clear: both;
}
#requests #clear {
float: right;
}
#requests ul {
list-style: none;
max-height: 100px;
overflow: auto;
margin: 0;
}
#requests ul li {
padding: 7px 0;
border-bottom: 1px solid #ddd;
}
#requests ul li:last-child {
border-bottom: none;
}
using DevExtreme.AspNet.Data;
using DevExtreme.AspNet.Mvc;
using Newtonsoft.Json;
using System;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Web.Http;
using DevExtreme.MVC.Demos.Models.Northwind;
using DevExtreme.MVC.Demos.Models.DataGrid;
using System.Collections.Generic;
namespace DevExtreme.MVC.Demos.Controllers {
[Route("api/DataGridWebApi/{action}", Name = "DataGridWebApi")]
public class DataGridWebApiController : ApiController {
InMemoryNorthwindContext _nwind = new InMemoryNorthwindContext();
[HttpGet]
public HttpResponseMessage Orders(DataSourceLoadOptions loadOptions) {
return Request.CreateResponse(DataSourceLoader.Load(_nwind.Orders, loadOptions));
}
[HttpPost]
public HttpResponseMessage InsertOrder(FormDataCollection form) {
var values = form.Get("values");
var newOrder = new Order();
JsonConvert.PopulateObject(values, newOrder);
Validate(newOrder);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
_nwind.Orders.Add(newOrder);
_nwind.SaveChanges();
return Request.CreateResponse(HttpStatusCode.Created, newOrder);
}
[HttpPut]
public HttpResponseMessage UpdateOrder(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var values = form.Get("values");
var order = _nwind.Orders.First(o => o.OrderID == key);
JsonConvert.PopulateObject(values, order);
Validate(order);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
_nwind.SaveChanges();
return Request.CreateResponse(HttpStatusCode.OK, order);
}
[HttpDelete]
public void DeleteOrder(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var order = _nwind.Orders.First(o => o.OrderID == key);
_nwind.Orders.Remove(order);
_nwind.SaveChanges();
}
// additional actions
[HttpGet]
public HttpResponseMessage OrderDetails(int orderID, DataSourceLoadOptions loadOptions) {
return Request.CreateResponse(DataSourceLoader.Load(
from i in _nwind.Order_Details
where i.OrderID == orderID
select new {
Product = i.Product.ProductName,
Price = i.UnitPrice,
i.Quantity,
Sum = i.UnitPrice * i.Quantity
},
loadOptions
));
}
[HttpGet]
public HttpResponseMessage ShippersLookup(DataSourceLoadOptions loadOptions) {
var lookup = from i in _nwind.Shippers
orderby i.CompanyName
select new {
Value = i.ShipperID,
Text = i.CompanyName
};
return Request.CreateResponse(DataSourceLoader.Load(lookup, loadOptions));
}
[HttpGet]
public HttpResponseMessage CustomersLookup(DataSourceLoadOptions loadOptions) {
var lookup = from i in _nwind.Customers
let text = i.CompanyName + " (" + i.Country + ")"
orderby i.CompanyName
select new {
Value = i.CustomerID,
Text = text
};
return Request.CreateResponse(DataSourceLoader.Load(lookup, loadOptions));
}
[HttpPost]
public HttpResponseMessage Batch(List<DataChange> changes) {
foreach(var change in changes) {
Order order;
if(change.Type == "update" || change.Type == "remove") {
var key = Convert.ToInt32(change.Key);
order = _nwind.Orders.First(o => o.OrderID == key);
} else {
order = new Order();
}
if(change.Type == "insert" || change.Type == "update") {
JsonConvert.PopulateObject(change.Data.ToString(), order);
Validate(order);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
if(change.Type == "insert") {
_nwind.Orders.Add(order);
}
change.Data = order;
} else if(change.Type == "remove") {
_nwind.Orders.Remove(order);
}
}
_nwind.SaveChanges();
return Request.CreateResponse(HttpStatusCode.OK, changes);
}
}
}
using System;
using System.Collections.Generic;
using System.Data.Entity;
namespace DevExtreme.MVC.Demos.Models.Northwind {
public class InMemoryNorthwindContext : InMemoryDataContext<Order> {
readonly NorthwindContext _nwind = new NorthwindContext();
public DbSet<Customer> Customers => _nwind.Customers;
public DbSet<Order_Detail> Order_Details => _nwind.Order_Details;
public ICollection<Order> Orders => ItemsInternal;
public DbSet<Shipper> Shippers => _nwind.Shippers;
protected override IEnumerable<Order> Source => _nwind.Orders;
protected override int GetKey(Order item) => item.OrderID;
protected override void SetKey(Order item, int key) => item.OrderID = key;
}
}

Backend API
<template>
<div>
<DxDataGrid
id="grid"
:show-borders="true"
:data-source="ordersData"
:repaint-changes-only="true"
>
<DxEditing
:refresh-mode="refreshMode"
:allow-adding="true"
:allow-updating="true"
:allow-deleting="true"
mode="cell"
/>
<DxColumn
data-field="CustomerID"
caption="Customer"
>
<DxLookup
:data-source="customersData"
value-expr="Value"
display-expr="Text"
/>
</DxColumn>
<DxColumn
data-field="OrderDate"
data-type="date"
/>
<DxColumn data-field="Freight"/>
<DxColumn data-field="ShipCountry"/>
<DxColumn
data-field="ShipVia"
caption="Shipping Company"
data-type="number"
>
<DxLookup
:data-source="shippersData"
value-expr="Value"
display-expr="Text"
/>
</DxColumn>
<DxScrolling mode="virtual"/>
<DxSummary>
<DxTotalItem
column="CustomerID"
summary-type="count"
/>
<DxTotalItem
column="Freight"
summary-type="sum"
value-format="#0.00"
/>
</DxSummary>
</DxDataGrid>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Refresh Mode: </span>
<DxSelectBox
v-model:value="refreshMode"
:input-attr="{ 'aria-label': 'Refresh Mode' }"
:items="refreshModes"
/>
</div>
<div id="requests">
<div>
<div class="caption">Network Requests</div>
<DxButton
id="clear"
text="Clear"
@click="clearRequests"
/>
</div>
<ul>
<li
v-for="(request, index) in requests"
:key="index"
>{{ request }}</li>
</ul>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import {
DxDataGrid,
DxColumn,
DxEditing,
DxScrolling,
DxSummary,
DxLookup,
DxTotalItem,
type DxDataGridTypes,
} from 'devextreme-vue/data-grid';
import { DxButton } from 'devextreme-vue/button';
import { DxSelectBox } from 'devextreme-vue/select-box';
import { CustomStore } from 'devextreme-vue/common/data';
import { formatDate } from 'devextreme-vue/common/core/localization';
import 'whatwg-fetch';
const URL = 'https://js.devexpress.com/Demos/NetCore/api/DataGridWebApi';
const ordersData = new CustomStore({
key: 'OrderID',
load: () => sendRequest(`${URL}/Orders`),
insert: (values) => sendRequest(`${URL}/InsertOrder`, 'POST', {
values: JSON.stringify(values),
}),
update: (key, values) => sendRequest(`${URL}/UpdateOrder`, 'PUT', {
key,
values: JSON.stringify(values),
}),
remove: (key) => sendRequest(`${URL}/DeleteOrder`, 'DELETE', {
key,
}),
});
const customersData = new CustomStore({
key: 'Value',
loadMode: 'raw',
load: () => sendRequest(`${URL}/CustomersLookup`),
});
const shippersData = new CustomStore({
key: 'Value',
loadMode: 'raw',
load: () => sendRequest(`${URL}/ShippersLookup`),
});
const refreshModes: DxDataGridTypes.GridsEditRefreshMode[] = ['full', 'reshape', 'repaint'];
const requests = ref<string[]>([]);
const refreshMode = ref(refreshModes[1]);
const sendRequest = async(url: string, method = 'GET', data: Record<string, string> = {}) => {
logRequest(method, url, data);
const request: any = {
method, credentials: 'include',
};
if (['DELETE', 'POST', 'PUT'].includes(method)) {
const params = Object.keys(data)
.map((key) => `${encodeURIComponent(key)}=${encodeURIComponent(data[key])}`)
.join('&');
request.body = params;
request.headers = { 'Content-Type': 'application/x-www-form-urlencoded;charset=UTF-8' };
}
const response = await fetch(url, request);
const isJson = response.headers.get('content-type')?.includes('application/json');
const result = isJson ? await response.json() : {};
if (!response.ok) {
throw result.Message;
}
return method === 'GET' ? result.data : {};
};
const logRequest = (method: string, url: string, data: Record<string, string>) => {
const args = Object.keys(data || {}).map((key) => `${key}=${data[key]}`).join(' ');
const time = formatDate(new Date(), 'HH:mm:ss');
requests.value.unshift([time, method, url.slice(URL.length), args].join(' '));
};
const clearRequests = () => {
requests.value = [];
};
</script>
<style scoped>
#grid {
height: 440px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
margin-bottom: 10px;
font-weight: 500;
font-size: 18px;
}
.option {
margin-bottom: 10px;
}
.option > span {
position: relative;
top: 2px;
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
#requests .caption {
float: left;
padding-top: 7px;
}
#requests > div {
padding-bottom: 5px;
}
#requests > div::after {
content: "";
display: table;
clear: both;
}
#requests #clear {
float: right;
}
#requests ul {
list-style: none;
max-height: 100px;
overflow: auto;
margin: 0;
}
#requests ul li {
padding: 7px 0;
border-bottom: 1px solid #ddd;
}
#requests ul li:last-child {
border-bottom: none;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'whatwg-fetch': 'npm:whatwg-fetch@2.0.4/fetch.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.4.5/lib/typescript.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app" />
</div>
</body>
</html>
using DevExtreme.AspNet.Data;
using DevExtreme.AspNet.Mvc;
using Newtonsoft.Json;
using System;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Formatting;
using System.Web.Http;
using DevExtreme.MVC.Demos.Models.Northwind;
using DevExtreme.MVC.Demos.Models.DataGrid;
using System.Collections.Generic;
namespace DevExtreme.MVC.Demos.Controllers {
[Route("api/DataGridWebApi/{action}", Name = "DataGridWebApi")]
public class DataGridWebApiController : ApiController {
InMemoryNorthwindContext _nwind = new InMemoryNorthwindContext();
[HttpGet]
public HttpResponseMessage Orders(DataSourceLoadOptions loadOptions) {
return Request.CreateResponse(DataSourceLoader.Load(_nwind.Orders, loadOptions));
}
[HttpPost]
public HttpResponseMessage InsertOrder(FormDataCollection form) {
var values = form.Get("values");
var newOrder = new Order();
JsonConvert.PopulateObject(values, newOrder);
Validate(newOrder);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
_nwind.Orders.Add(newOrder);
_nwind.SaveChanges();
return Request.CreateResponse(HttpStatusCode.Created, newOrder);
}
[HttpPut]
public HttpResponseMessage UpdateOrder(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var values = form.Get("values");
var order = _nwind.Orders.First(o => o.OrderID == key);
JsonConvert.PopulateObject(values, order);
Validate(order);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
_nwind.SaveChanges();
return Request.CreateResponse(HttpStatusCode.OK, order);
}
[HttpDelete]
public void DeleteOrder(FormDataCollection form) {
var key = Convert.ToInt32(form.Get("key"));
var order = _nwind.Orders.First(o => o.OrderID == key);
_nwind.Orders.Remove(order);
_nwind.SaveChanges();
}
// additional actions
[HttpGet]
public HttpResponseMessage OrderDetails(int orderID, DataSourceLoadOptions loadOptions) {
return Request.CreateResponse(DataSourceLoader.Load(
from i in _nwind.Order_Details
where i.OrderID == orderID
select new {
Product = i.Product.ProductName,
Price = i.UnitPrice,
i.Quantity,
Sum = i.UnitPrice * i.Quantity
},
loadOptions
));
}
[HttpGet]
public HttpResponseMessage ShippersLookup(DataSourceLoadOptions loadOptions) {
var lookup = from i in _nwind.Shippers
orderby i.CompanyName
select new {
Value = i.ShipperID,
Text = i.CompanyName
};
return Request.CreateResponse(DataSourceLoader.Load(lookup, loadOptions));
}
[HttpGet]
public HttpResponseMessage CustomersLookup(DataSourceLoadOptions loadOptions) {
var lookup = from i in _nwind.Customers
let text = i.CompanyName + " (" + i.Country + ")"
orderby i.CompanyName
select new {
Value = i.CustomerID,
Text = text
};
return Request.CreateResponse(DataSourceLoader.Load(lookup, loadOptions));
}
[HttpPost]
public HttpResponseMessage Batch(List<DataChange> changes) {
foreach(var change in changes) {
Order order;
if(change.Type == "update" || change.Type == "remove") {
var key = Convert.ToInt32(change.Key);
order = _nwind.Orders.First(o => o.OrderID == key);
} else {
order = new Order();
}
if(change.Type == "insert" || change.Type == "update") {
JsonConvert.PopulateObject(change.Data.ToString(), order);
Validate(order);
if(!ModelState.IsValid)
return Request.CreateErrorResponse(HttpStatusCode.BadRequest, ModelState.GetFullErrorMessage());
if(change.Type == "insert") {
_nwind.Orders.Add(order);
}
change.Data = order;
} else if(change.Type == "remove") {
_nwind.Orders.Remove(order);
}
}
_nwind.SaveChanges();
return Request.CreateResponse(HttpStatusCode.OK, changes);
}
}
}
using System;
using System.Collections.Generic;
using System.Data.Entity;
namespace DevExtreme.MVC.Demos.Models.Northwind {
public class InMemoryNorthwindContext : InMemoryDataContext<Order> {
readonly NorthwindContext _nwind = new NorthwindContext();
public DbSet<Customer> Customers => _nwind.Customers;
public DbSet<Order_Detail> Order_Details => _nwind.Order_Details;
public ICollection<Order> Orders => ItemsInternal;
public DbSet<Shipper> Shippers => _nwind.Shippers;
protected override IEnumerable<Order> Source => _nwind.Orders;
protected override int GetKey(Order item) => item.OrderID;
protected override void SetKey(Order item, int key) => item.OrderID = key;
}
}